== Change Log

=== 5.3.1-FUSE-03-00
* [AMQ-2952|https://issues.apache.org/activemq/browse/AMQ-2952]: message groups with small prefetch
* [MB-699|http://fusesource.com/issues/browse/MB-699]: Temporary queues create advisory topics without bound ([AMQ-2571|https://issues.apache.org/jira/browse/AMQ-2571])
* [MB-735|http://fusesource.com/issues/browse/MB-735]: Message groups not honored or balanced on reconnected consumers ([AMQ-2952|https://issues.apache.org/jira/browse/AMQ-2952])
* [AMQ-2993|https://issues.apache.org/activemq/browse/AMQ-2993]: Virtual topic interceptor process advisory messages
* [MB-762|http://fusesource.com/issues/browse/MB-762]: Message is lost while browsing composite queues over the network ([AMQ-3020|https://issues.apache.org/activemq/browse/AMQ-3020])

=== 5.3.1-FUSE-02-01
* [MB-692|http://fusesource.com/issues/browse/MB-692]: Lots of NullPointerException in KahaDB after restart ([AMQ-2757|https://issues.apache.org/activemq/browse/AMQ-2757])
* [MB-685|http://fusesource.com/issues/browse/MB-685]: Invalid messages in the pending queue of durable subscriptions ([AMQ-2695|https://issues.apache.org/activemq/browse/AMQ-2695])
* [MB-680|http://fusesource.com/issues/browse/MB-680]: Network of Brokers becomes overwhelmed with Advisory Messages on Temporary Queues ([AMQ-2782|https://issues.apache.org/activemq/browse/AMQ-2782])
* [MB-687|http://fusesource.com/issues/browse/MB-687]: Durable subscription MBean shows incorrect active/inactive state. ([AMQ-2770|https://issues.apache.org/activemq/browse/AMQ-2770])
* [MB-683|http://fusesource.com/issues/browse/MB-683]: Durable subscription re-activation increases the consumers list ([AMQ-2665|https://issues.apache.org/activemq/browse/AMQ-2665]) 
* [MB-682|http://fusesource.com/issues/browse/MB-682]: Failed durable subscription re-activation when keepDurableSubsActive=false ([AMQ-2663|https://issues.apache.org/activemq/browse/AMQ-2663])

=== 5.3.1-FUSE-02-00

* [MB-674|http://fusesource.com/issues/browse/MB-674]: Extra "vm://localhost" is added to the failover URL in HA mode ([AMQ-2767|https://issues.apache.org/activemq/browse/AMQ-2767])
* [MB-676|http://fusesource.com/issues/browse/MB-676]: Ensure that messages are re-routed in cyclic networks when one link goes down ([AMQ-2753|https://issues.apache.org/activemq/browse/AMQ-2753])
* [MB-677|http://fusesource.com/issues/browse/MB-677]: Include fuse console

=== 5.3.1-fuse-01-00
* [MB-677|http://fusesource.com/issues/browse/MB-677]: Include fuse console
* [MB-676|http://fusesource.com/issues/browse/MB-676]: Ensure that messages are re-routed in cyclic networks when one link goes down
* [MB-669|http://fusesource.com/issues/browse/MB-669]: synchronize fix level with activemq 5.3.2 minor maintenance release 
* [MB-655|http://fusesource.com/issues/browse/MB-655]: Multiple duplicate messages and extra durable subscription created after a broker in a network of brokers is restarted ([AMQ-2691|https://issues.apache.org/activemq/browse/AMQ-2691],[AMQ-2704|https://issues.apache.org/activemq/browse/AMQ-2704],[AMQ-2720|https://issues.apache.org/activemq/browse/AMQ-2720])
* [MB-639|http://fusesource.com/issues/browse/MB-639]: Auto acknowledged session does not redeliver message in case of exception ([AMQ-906|https://issues.apache.org/activemq/browse/AMQ-906])
* [MB-658|http://fusesource.com/issues/browse/MB-658]: Transport connector throws SSL exception when network connector is configured to failover over ssl transport ([AMQ-2715|https://issues.apache.org/activemq/browse/AMQ-2715])
* [AMQ-2556|https://issues.apache.org/activemq/browse/AMQ-2556]: Memory leaks with XA Transactions (case of read-only transactions)
* [AMQ-2714|https://issues.apache.org/activemq/browse/AMQ-2714]: Apache ActiveMQ is prone to XSS Vulnerability
* [MB-654|http://fusesource.com/issues/browse/MB-654]:  org.apache.activemq.pool.ConnectionPool maintains stale connections when Client Connections Attempt to Connect before Broker is started ([AMQ-2677|https://issues.apache.org/activemq/browse/AMQ-2677])
* [MB-663|http://fusesource.com/issues/browse/MB-663]: Include exploring-jms examples
* [MB-662|http://fusesource.com/issues/browse/MB-662]: Purge in Jconsole could cause CPU spinning ([AMQ-2323|https://issues.apache.org/activemq/browse/AMQ-2323])
* [AMQ-2675|https://issues.apache.org/activemq/browse/AMQ-2675]: UnsupportedOperationException in web admin when creating topic
* [AMQ-2700|https://issues.apache.org/activemq/browse/AMQ-2700]: Apache ActiveMQ is prone to source code disclosure vulnerability.
* [MB-659|http://fusesource.com/issues/browse/MB-659]: Bug in PooledConnectionFactoryBean in version 5.3.1-fuse-00-00
* [MB-656|http://fusesource.com/issues/browse/MB-656]: Set correlationId on returned messages from the BrokerStatisticsPlugin ([AMQ-2461|https://issues.apache.org/activemq/browse/AMQ-2461])

=== 5.3.1-fuse-00-00
* [AMQ-2656|https://issues.apache.org/activemq/browse/AMQ-2656] : ActiveMQInitialConnectionFactory cannot return an XAConnectionFactory

=== 5.3.0-fuse-00-02
* [MB-650|http://fusesource.com/issues/browse/MB-650]: Fuse MB slave in shared filesystem master/slave setup reports Slave=false in JMX ([AMQ-2669|https://issues.apache.org/activemq/browse/AMQ-2669])

=== 5.3.0-fuse-00-01
* [AMQ-2196|https://issues.apache.org/activemq/browse/AMQ-2196]: InactivityMonitor should not simply use the minimum of the local and remote maxInactivityDuration parameter
* [AMQ-2352|https://issues.apache.org/activemq/browse/AMQ-2352]: JMX user / pass swapped fix
* [AMQ-2589|https://issues.apache.org/activemq/browse/AMQ-2589]: NullPointer in MessageDatabase.java on restarting after ungraceful exit 
* [AMQ-2548|https://issues.apache.org/activemq/browse/AMQ-2548]: Downloading Blob messages via FTP fails for files larger than 64KB
* [MB-604|http://fusesource.com/issues/browse/MB-604]: producer flow control timeout ([AMQ-2507|https://issues.apache.org/activemq/browse/AMQ-2507])
* [AMQ-2530|http://issues.apache.org/activemq/browse/AMQ-2530]: memory leak in ConduitBridge (subscriptionMapByRemoteId)
* [AMQ-2574|https://issues.apache.org/activemq/browse/AMQ-2574]: Try to stop OSGi bundle when closing application context
* [AMQ-2570|https://issues.apache.org/activemq/browse/AMQ-2570]: ActiveMQ Karaf support
* [AMQ-2550|https://issues.apache.org/activemq/browse/AMQ-2550]: Unresolved constraint in bundle org.apache.activemq.activemq-core: package; (&(package=org.osgi.framework)(version>=1.4.0)(!(version>=1.5.0)))
* [AMQ-2512|https://issues.apache.org/activemq/browse/AMQ-2512]: Failed to page in more queue messages
* [AMQ-2573|https://issues.apache.org/activemq/browse/AMQ-2573]: Failover with async rollback of message audit can lead to over eager duplicate suppression (auto acking) and apparent missing messages
* [AMQ-2567|https://issues.apache.org/activemq/browse/AMQ-2567]: Zero Prefetch not working
* [MB-623|http://fusesource.com/issues/browse/MB-623]: JMX property inflight count not updated correctly when used with transactions and rollbacks occur ([AMQ-2566|https://issues.apache.org/activemq/browse/AMQ-2566])
* [AMQ-2560|https://issues.apache.org/activemq/browse/AMQ-2560]: Failover reconnect with outstanding consumer transaction can result in javax.jms.JMSException: Unmatched acknowledege: MessageAck and lost ack
* [AMQ-2572|https://issues.apache.org/activemq/browse/AMQ-2572]: Timing issue on consumer close can lead to unconsumed messages being inadvertently marked as duplicates and not getting delivered
* [AMQ-2569|https://issues.apache.org/activemq/browse/AMQ-2569]: ctivemq-core/META-INF/spring.schema should include the released activemq-core.xsd
* [AMQ-2488|https://issues.apache.org/activemq/browse/AMQ-2488]: Unable to access Serializable class when receiving ObjectMessage in OSGi environment
* [AMQ-2475|http://issues.apache.org/activemq/browse/AMQ-2475]: If tmp message store fills up, broker can deadlock due to while producers wait on disk space and consumers wait on acks
* [AMQ-2523|https://issues.apache.org/activemq/browse/AMQ-2523]: separate thread pool per Usage requires lots of threads when separate MemoryUsage defined for each destination 
* [AMQ-2527|https://issues.apache.org/activemq/browse/AMQ-2527]: Intermittent hang of AMQ2102Test with ibm jdk - demonstrated sync issue with message properties and dlq processing for topics
* [AMQ-2508|https://issues.apache.org/activemq/browse/AMQ-2508]: Activemq should not force third party login modules to use the GroupPrincipal implementation
* [AMQ-2539|https://issues.apache.org/activemq/browse/AMQ-2539]: Creating temporary destinations omits security checkings
* [AMQ-2473|https://issues.apache.org/activemq/browse/AMQ-2473]: Async error occurred: java.lang.NullPointerException
* [AMQ-2540|https://issues.apache.org/activemq/browse/AMQ-2540]: Duplicate suppression lack of recovery with JDBCStore can result in "hung" queue afer failover of outstanding send or transaction
* [AMQ-2553|https://issues.apache.org/activemq/browse/AMQ-2553]: Browsing dlq over transacted session
* [ESB-1039|http://fusesource.com/issues/browse/ESB-1039]: Upgrade Camel to 2.1.0-psc-01-00RC1
* [AMQ-2511|https://issues.apache.org/activemq/browse/AMQ-2511]: Regression: Inactivity monitor does not time out stale connections.
* [MB-611|http://fusesource.com/issues/browse/MB-611]: Message can be consumed twice over network of brokers ([AMQ-2529|https://issues.apache.org/activemq/browse/AMQ-2529])
* [AMQ-1498|https://issues.apache.org/activemq/browse/AMQ-1498]: Broker doesn't start anymore!
* [AMQ-2519|https://issues.apache.org/activemq/browse/AMQ-2519]: Prevent JDBC store to persist the same message twice
* [AMQ-2516|https://issues.apache.org/activemq/browse/AMQ-2516]: SecurityException raised when broker tries to move expired message to DLQ
* [AMQ-2515|https://issues.apache.org/activemq/browse/AMQ-2515]: Improve Optimized Acknowledgements behavior when transport is interrupted
* [AMQ-2489|https://issues.apache.org/activemq/browse/AMQ-2489]: Could not correlate acknowledgment with dispatched message" exception
* [AMQ-2525|https://issues.apache.org/activemq/browse/AMQ-2525]: Prevent broker deadlock if jmxconnector start hangs
* [AMQ-2513|https://issues.apache.org/activemq/browse/AMQ-2513]: JMX bug - javax.management.InstanceNotFoundException
* [AMQ-2462|https://issues.apache.org/activemq/browse/AMQ-2462]: New activemq-admin commands
* [AMQ-2352|https://issues.apache.org/activemq/browse/AMQ-2352]: it should be possible to specify userName and password in the webconsole-properties.xml
* [AMQ-2463|https://issues.apache.org/activemq/browse/AMQ-2463]: Transaction isolation level should be configurable in jdbcpersistence adapter - TRANSACITON_READ_UNCOMMITTED blows on MySQL with binlog
* [AMQ-2447|https://issues.apache.org/activemq/browse/AMQ-2447]: help for activemq:bstat is acutally showing the help for activemq:query
* [AMQ-2314|https://issues.apache.org/activemq/browse/AMQ-2314]: https://issues.apache.org/activemq/browse/AMQ-2314
* [MB-592|http://fusesource.com/issues/browse/MB-592]: Shutdown broker if default message store cannot access the disk (AMQ-2042|https://issues.apache.org/activemq/browse/AMQ-2042)
* [AMQ-2502|https://issues.apache.org/activemq/browse/AMQ-2502]: activemq-camel is missing an optional Import-Package for org.apache.activemq.pool
* [MB-600|http://fusesource.com/issues/browse/MB-600]: Request to remove user's password details in DEBUG mode ([AMQ-2499|https://issues.apache.org/activemq/browse/AMQ-2499])
* [MB-599|http://fusesource.com/issues/browse/MB-599]: Warning about using default locking mechanism should be an info ([AMQ-2493|https://issues.apache.org/activemq/browse/AMQ-2493])
* [AMQ-2492|https://issues.apache.org/activemq/browse/AMQ-2492]: Microsoft SQL Server JDBC Driver 2.0 not recognized
* [AMQ-2487|https://issues.apache.org/activemq/browse/AMQ-2487]: MemoryUsage not properly accounted for when expiring messages to DLQ: can lead to hang.
* [AMQ-2486|https://issues.apache.org/activemq/browse/AMQ-2486]: systemExitOnShutdown="true" causes broker shutdown to hang 
* [AMQ-2439|https://issues.apache.org/activemq/browse/AMQ-2439]: KahaDB + Network of Brokers + Restart = Duplicate Messages that cannot be removed from the data store  
* [AMQ-2028|https://issues.apache.org/activemq/browse/AMQ-2028]: ActiveMQSessionExecutor.taskRunner usage is very non-thread-safe
* [AMQ-2483|https://issues.apache.org/activemq/browse/AMQ-2483]: OOM due to build of of iterate executions during bulk message consumption - asyncWakeup called excessively 
* [AMQ-2472|https://issues.apache.org/activemq/browse/AMQ-2472]: NullPointerException during startup of DiscoveryNetworkConnector when using an HTTP URL for an inactive remote broker.
* [AMQ-2449|https://issues.apache.org/activemq/browse/AMQ-2449]: Peer certificates not propagated when using stomp+ssl w/mutual authentication
* [AMQ-2474|https://issues.apache.org/activemq/browse/AMQ-2474]: Enable broker-to-broker authentication and authorizarion using SSL certificates and jaasCertificateAuthenticationPlugin
* [AMQ-2410|https://issues.apache.org/activemq/browse/AMQ-2410]: Web console queues index misses sort link on table header
* [AMQ-2478|https://issues.apache.org/activemq/browse/AMQ-2478]: Too many files open error, after no space left on device occurs; if producer carries on sending messages
* [AMQ-2306|https://issues.apache.org/activemq/browse/AMQ-2306]: Unable to monitor or manage slave brokers in shared filesystem master slave configuration
* [AMQ-2481|https://issues.apache.org/activemq/browse/AMQ-2481]: OOM due to message expiry processing with large numbers of messages in queue because of slow or absent consumers
* [MB-560|http://fusesource.com/issues/browse/MB-560]: Calling purge on a large queue causes OutOfMemoryError in the broker ([AMQ-2468|https://issues.apache.org/activemq/browse/AMQ-2468])
* [MB-558|http://fusesource.com/issues/browse/MB-558]: JMS clients stalled in case of many messages on a different queue (AMQ-2470|https://issues.apache.org/activemq/browse/AMQ-2470])
* [AMQ-1112|http://issues.apache.org/activemq/browse/AMQ-1112]: remove expired messages from Store and update Message cursors

===  5.3.1.0-fuse

* All changes included in Apache ActiveMQ 5.3.0 release
